routes/web.php
    Route::get('/resources', 'ResourceController@index');

    Route::get('/collections/search', 'CollectionController@search');
    Route::get('/collections', 'CollectionController@index');

    Route::get('/{slug}/resources', 'CategoryController@resources');
    Route::resource('/categories', 'CategoryController');

    // show resource create form
    //Route::get('/resources/create', 'ResourceController@create')->middleware('auth');

    Route::get('app#/recursos/{id}', 'ResourceController@show');

   
    Route::group(['prefix' => '/resources/{slug}'], function () {
        // show single resource
        Route::get('/', 'ResourceController@show');
        Route::get('/edit', 'ResourceController@edit');

        // Download Resource
        Route::get('/download', 'ResourceController@download');
    });

    Route::group(['prefix' => '/collections/{slug}'], function () {
        // show single resource
        Route::get('/', 'CollectionController@show');
    });
});
/***
    Route::prefix('/')->namespace('Auth')->group(function () {
        // show web login form
        Route::get('login', 'LoginController@showLoginForm')->name('login');

        // show web registration form
        Route::get('register', 'LoginController@showRegistrationForm');
        Route::get('register-ok', 'LoginController@showRegistrationSuccess');

        //Password Reset Routes...
        Route::get('password-reset', 'ForgotPasswordController@showLinkRequestForm');
        Route::post('password/email', 'ForgotPasswordController@sendResetLinkEmail')->name('password.email');
        Route::get('password/reset', 'ResetPasswordController@showResetForm')->name('password.reset');
        Route::post('password/resetV2', 'ResetPasswordController@updatePassword')->name('password.update');
    });
*** */
Route::post('password/resetV2', 'Auth\ResetPasswordController@updatePassword')->name('password.update');
    Route::prefix('/')->namespace('Api\V1')->group(function () {

        // login from web by using api
        Route::post('login', 'AuthenticateController@authenticate');

        // logout from web by using api
        Route::post('logout', 'AuthenticateController@logout');
    });

    Route::group(['prefix' => 'users', 'namespace' => 'Api\V1'], function () {

        Route::get('/', 'UserController@index');
        Route::post('/', 'UserController@store');

        // User Methods
        Route::group(['prefix' => '{id}'], function () {

            Route::get('/', 'UserController@show');
            Route::put('/', 'UserController@update');
            Route::delete('/', 'UserController@delete');

            // Get User Profile
            Route::get('profile', 'UserController@getProfile');

            // Update user password
            //Route::post('password/reset', 'Auth\PasswordController@postReset');

            Route::put('profile', 'UserController@updateProfile');
            Route::post('profile/image', 'UserController@updateImage');
            Route::post('password/update', 'UserController@updatePassword');
            Route::delete('profile/image', 'UserController@deleteImage');
            Route::post('/avatar', 'UserController@setAvatar');
            Route::get('/settings', 'UserController@getSettings');
            Route::post('/settings', 'UserController@setSettings');
        });
    });

    Route::group(['prefix' => 'polls', 'namespace' => 'Api\V1'], function () {
        Route::post('/{id}/vote', 'PollController@vote');
        Route::get('/{id}/result', 'PollController@result');
        Route::get('/last', 'PollController@last');

        Route::resource('/', 'PollController');
    });




Route::get('/webapi/resources', 'Api\V1\ResourceController@index');
Route::get('/webapi/resources-by-query', 'Api\V1\ResourceController@getResourcesByQuery');
Route::post('/webapi/resources', 'Api\V1\ResourceController@store');
Route::get('/webapi/resources/latest', 'Api\V1\ResourceController@getLatestResources');
Route::get('/webapi/resources/latest/{id}', 'Api\V1\ResourceController@getLatestResourcesByAuthor');
Route::get('/webapi/resources/ranked/{id}', 'Api\V1\ResourceController@getRankedResourcesByAuthor');
Route::post('/webapi/resources/{id}/like', 'Api\V1\ResourceController@like');
Route::get('/webapi/resources/{id}', 'Api\V1\ResourceController@show');
Route::post('/webapi/resources/{id}', 'Api\V1\ResourceController@updateResource');
Route::post('/webapi/resources/{id}/file', 'Api\V1\ResourceController@updateFileResource');
Route::post('/webapi/resources/{id}/new-update', 'Api\V1\ResourceController@newUpdate');
Route::get('/webapi/resources/{id}/edit', 'Api\V1\ResourceController@edit');
Route::post('/webapi/resources/updateInfo/{id}', 'Api\V1\ResourceController@updateInfo');
Route::post('/webapi/resources/file/delete', 'Api\V1\ResourceController@fileDelete');
Route::get('/webapi/resources/{slug}/download-content', 'Api\V1\ResourceController@downloadContent');
Route::get('/webapi/resources/{slug}/download-attachment', 'Api\V1\ResourceController@downloadAttachment');
Route::post('/webapi/ratings', 'Api\V1\RatingController@setRating');

//Route::get('/webapi/collections/{collection_id}/resources', 'Api\V1\CollectionController@getResources');
Route::get('/webapi/collections/{collection_id}/resources', 'Api\V1\CollectionController@getResourcesByCollection');
Route::post('/webapi/collections/sync/resources', 'Api\V1\CollectionController@syncResources');
Route::get('/webapi/collections/{slug}', 'Api\V1\CollectionController@show');


Route::get('/webapi/tags', 'Api\V1\ResourceController@searchTags');
Route::get('/webapi/author/{id}', 'Api\V1\ResourceController@getAuthor');
Route::get('/webapi/authors', 'Api\V1\ResourceController@searchAuthors');

Route::resource('/tags', 'Api\V1\TagController');

Route::get('/ads', 'Api\V1\ResourceController@getAds');
Route::get('/linker/{uuid}', 'Api\V1\ResourceController@linker');
Route::get('/mailablex', function () {
    return new \App\Mail\UserActivationCode(App\Models\User::find(1));
});
Route::get('/mailable/{email}', function ($email) {
    Mail::raw('Test email', function ($message) use ($email) {
        $message->subject('Testing Mailables')
            ->to($email);
    });
});

Route::get('/launching/{email}', function ($email) {
    Mail::to($email)->send(new \App\Mail\LaunchingV2());
});

/* Route::get('/elasticsearch/{query}', 'ElasticSearchController@search');
Route::resource('/elastic', 'ElasticSearchController'); */


Route::post('/accept', 'Web\HomeController@acceptTerms');
Route::get('/badges', 'Web\HomeController@badges');

//login admin
Route::post('loginAdmin', 'LoginAdminController@loginAdmin');
Route::get('admin_login', 'LoginAdminController@loginAdminView');

Route::get('reset_password', 'ResetPasswordController@index');


Route::group(['prefix' => 'admin', 'namespace' => 'Web'], function() {
    //'middleware' => 'backend',
//oute::group(['prefix' => 'admin', 'namespace' => 'Web','middleware' => 'backend'], function() {
    // Rutas de los controladores dentro del Namespace "App\Http\Controllers\Admin"
    Route::view('/', 'dashboard.index')->name('admin');

    //ads
    Route::resource('/ads', 'AdminAdsController');

    Route::get('/password-reset/token={token}', 'AdminUserController@showEmail');
    //recursos
    Route::get('/recursos/datatables', 'AdminResourceController@getDatatable');
    Route::resource('/recursos', 'AdminResourceController');
    Route::post('/recursos/publishedResources/{id}', 'AdminResourceController@publishedResources');
    Route::post('/recursos/recover/{id}', 'AdminResourceController@recover')->name('recursos.recover');

    //publicamos recurso
    Route::get('/recursos/{id}/status', 'AdminResourceController@togglePublished')->name('recursos.published');

    //usuarios
    Route::get('/usuarios/datatables', 'AdminUserController@getDatatable');
    Route::post('/usuarios/avatar', 'AdminUserController@manageAvatar');
    Route::resource('/usuarios', 'AdminUserController');

    //encuestas
    Route::get('encuestas', 'AdminPollController@index');
    //Route::resource('/encuestas', 'Web\AdminPollController')->middleware('backend');

    Route::resource('/encuestas', 'AdminPollController');
    Route::get('/encuestas/{id}/status', 'AdminPollController@status')->name('encuestas.status');
    Route::get('/encuestas/datatables', 'AdminPollController@getDatatable');

    //collections
    Route::get('/collections/datatables', 'AdminCollectionController@getDatatable');
    Route::get('/collections/resources/{collection_id}', 'AdminCollectionController@resources');
    Route::resource('/collections', 'AdminCollectionController');

    //resource
    //Route::get('/resources/{id}', 'AdminResourceController@edit');
    Route::get('/resources/edit/{resource_id}', 'AdminResourceController@edit');
   // Route::get('resourceEdit','AdminResourceController@edit');
    //notifications
    Route::get('/notifications', 'AdminNotificationController@index')->name('notifications.index');
    Route::get('/notifications/{id}/read', 'AdminNotificationController@markAsRead')->name('notification.read');
    Route::get('/notifications/read', 'AdminNotificationController@markAllAsRead')->name('notification.all.read');
    Route::get('/notifications/unread', 'Web\NotificationController@getUnreadNotifications');

    //gallery
    Route::get('/gallery','GalleryController@index')->name('gallery.index');
    Route::get('/gallery/order','GalleryController@order')->name('gallery.order');
    Route::get('/gallery/datatables','GalleryController@getDatatable');
    Route::get('/gallery/create','GalleryController@create')->name('gallery.create');
    Route::post('/gallery/create','GalleryController@store')->name('gallery.store');
    Route::get('/gallery/edit/{id}','GalleryController@edit')->name('gallery.edit');
    Route::post('/gallery/edit/{id}','GalleryController@update')->name('gallery.update');

app/Http/Controllers/Api/V1/PollController.php
<?php

namespace App\Http\Controllers\Api\V1;

use Auth;
use Carbon\Carbon;
use App\Models\Poll;
use App\Models\User;

use App\Models\PollOption;
use App\Models\PollVote;
use App\Service\CommonService;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Http\Requests\Poll\PollCreateRequest;
use App\Http\Requests\Poll\PollVoteRequest;
use stdClass;
class PollController extends Controller
{
    use CommonService;

    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        /*$this->middleware('auth:api', [
            'except' => [
                'index',
                'show',
                'last'
            ]
        ]);*/
    }

    public function index()
    {
        return response()->json(Poll::simplePaginate(10));
    }

    public function show($id)
    {
        return response()->json(Poll::with('options')->findOrFail($id), 200);
    }
    public function getActivePoll(Request $request)
    {
        $user = User::find(Auth::user()->id);
        $poll = Poll::where([['active','=',True]])->first();
        $hasVoted = Auth::user()->pollVote()
            ->where('poll_id', $poll->id)
            ->first();
        if(isset($poll->id)){
            if($hasVoted == null){
                $poll->hasVoted = False;
            }else{
                $poll->hasVoted = True;
            }
            
            $poll->Options;
            return $this->setResponse($poll, 'success', 'OK', '200', '', '');

        }else{
            return $this->setResponse([], 'success', 'OK', '200', '', '');
        }
    }
    public function last(Request $request)
    {
        $today = Carbon::now()->format('Y-m-d');
        $poll = Poll::with(
            [
                'options' => function ($query) {
                    $query->where('option', '<>', '');
                }
            ]
        )->orderBy('created_at', 'asc')
            ->where('active', '=', '1')
            ->whereDate('date_from', '<=', $today)
            ->whereDate('date_to', '>=', $today)
            ->first();

        if ($poll) {
            foreach ($poll->options as $option) {
                $option->count = PollVote::where('poll_id', $poll->id)
                    ->where('poll_options_id', $option->id)
                    ->count();
            }

            $poll->voted = false;
            if (Auth::check()) {
                $voted = $poll->votes->where('user_id', $request->user()->id);
                $poll->voted = (boolean)count($voted);
            }
        }

        return $this->setResponse($poll, 'success', 'OK', '200', '', '');
    }

    public function store(PollCreateRequest $request)
    {
        $poll = Poll::create([
            'question' => $request->question,
            'date_from' => $request->date_from,
            'date_to' => $request->date_to,
            'active' => $request->active
        ]);

        $options = array_map(function ($option, $key) {
            return new PollOption([
                'option' => $option,
                'index' => $key
            ]);
        }, $request->options, array_keys($request->options));

        $poll->options()->saveMany($options);

        $poll->load('options');

        return response()->json($poll, 200);
    }

    public function update(PollCreateRequest $request, $id)
    {
        $poll = Poll::find($id);

        $poll->question = $request->question;
        $poll->date_from = $request->date_from;
        $poll->date_to = $request->date_to;
        $poll->active = $request->active;

        $poll->options()->delete();

        $options = array_map(function ($option, $key) {
            return new PollOption([
                'option' => $option,
                'index' => $key
            ]);
        }, $request->options, array_keys($request->options));

        $poll->options()->saveMany($options);
        $poll->save();
        $poll->load('options');

        return response()->json($poll, 200);
    }
    public function sendPoll(Request $request)
    {
        $user = User::find(Auth::user()->id);
        $hasVoted = Auth::user()->pollVote()
            ->where('poll_id', $request->poll_id)
            ->first();
        $message = "Tu voto ya habia sido registrado";
        if (!$hasVoted) {
            $pollVote = new PollVote([
                'poll_id' => $request->poll_id,
                'poll_options_id' => $request->poll_options_id
            ]);

            Auth::user()->pollVote()->save($pollVote);
            $message = "Gracias por tu voto!";
        }

        return response()->json(['status' => 1, 'message' => $message], 200);
    }
    public function GetStatisticsPoll()
    {
        $statistics = PollVote::where([['poll_id','=',1]])->get();
        $data = new stdClass;
        $total_polls = 0;
        foreach($statistics as $statistic){
            $detail = new stdClass;
            $name = $statistic->poll_options_id;
            if(isset($data->$name)){
                $detail = $data->$name;
                $detail->number = $detail->number+1;
                $data->$name = $detail;
            }else{
                $detail->number = 1;
                $option = PollOption::find($name);
                $detail->name = $option->option;
                $data->$name = $detail;
            }
            $total_polls = $total_polls+1;
        }
        foreach($data as $dt){
            $dt->porcent = round((($dt->number*100)/$total_polls),2);
        }
        return response()->json(['status' => 1, 'data' => $data], 200);

    }
    public function vote(PollVoteRequest $request, $id)
    {
        $hasVoted = Auth::user()->pollVote()
            ->where('poll_id', $id)
            ->first();

        $message = "Tu voto ya habia sido registrado";

        if (!$hasVoted) {
            $pollVote = new PollVote([
                'poll_id' => $id,
                'poll_options_id' => $request->option
            ]);

            Auth::user()->pollVote()->save($pollVote);
            $message = "Gracias por tu voto!";
        }

        return response()->json(['status' => 1, 'message' => $message], 200);
    }

    public function result($id)
    {
        $poll = Poll::with('options.votes', 'options.votes.user')->findOrFail($id);
        return $this->setResponse($poll, 'success', 'OK', '200', 'Vota el éxito', 'Gracias! Tu voto ha sido enviado');
    }
}

resources/views/dashboard/polls/create.blade.php
@extends('layouts.dashboard')

@section('content')
    <div class="container-fluid">
        <div class="row page-titles">
            <div class="col-md-6 col-8 align-self-center">
                {{--<h3 class="text-themecolor mb-0 mt-0">Recursos</h3>--}}
                <ol class="breadcrumb">
                    <li class="breadcrumb-item"><a href="javascript:void(0)">Encuestas</a></li>
                    <li class="breadcrumb-item active">Crear</li>
                </ol>
            </div>
        </div>
        <div class="row">
            <div class="col">
                <div class="card">
                    <div class="card-body">
                        @include('dashboard.partials.flash-message')
                        <h4 class="card-title">Crear encuesta</h4>
                        {{--<h6 class="card-subtitle"> All with bootstrap element classies </h6>--}}
                        <form id="form-create-poll" class="mt-4" action="{{route('encuestas.store')}}" method="POST">
                            {{csrf_field()}}
                            <div class="form-group">
                                <label>Pregunta</label>
                                <input type="text" class="form-control" name="question" aria-describedby="emailHelp"/>
                            </div>
                            <div class="row form-group">
                                <div class="form-group col-6">
                                    <label>Fecha de inicio:</label>
                                    <input type="date" name="date_from" class="form-control" v-model="date_from">
                                </div>
                                <div class="form-group col-6">
                                    <label>Fecha de fin:</label>
                                    <input type="date" name="date_to" class="form-control" v-model="date_to">
                                </div>
                            </div>
                            <input type="hidden" name="former_id" class="form-control" value="0">
                            <div class="form-group">
                                <label>Respuestas</label>
                                <div v-for="(response, key) in responses" class="d-flex">
                                    <input type="text" class="form-control my-1 mr-1" name="responses[]"
                                           style="display: inline-block" v-model="responses[key]"/>
                                    <button class="btn btn-danger btn-sm my-1 ml-1"
                                            @click.prevent="deleteResponse(key)">Eliminar
                                    </button>
                                </div>
                                <button class="btn btn-success btn-sm my-3 d-block" @click.prevent="addResponse">Agregar
                                    respuesta
                                </button>
                            </div>
                            <button type="submit" class="btn btn-primary">Crear encuesta</button>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
    @include('dashboard.partials.footer')
@endsection

@section('script')
    <script>
        const app = new Vue({
            el: '#form-create-poll',
            data() {
                return {
                    responses: [],
                    date_from: null,
                    date_to: null,
                }
            },
            mounted() {
                let today = new Date().toISOString().slice(0, 10);
                this.date_from = today;
                this.date_to = today;
            },
            methods: {
                addResponse() {
                    this.responses.push("");
                },
                deleteResponse(key) {
                    this.responses.splice(key, 1);
                },
            },

        });
    </script>
@endsection

resources/views/dashboard/polls/edit.blade.php
@extends('layouts.dashboard')

@section('content')
    <!-- ============================================================== -->
    <!-- Container fluid  -->
    <!-- ============================================================== -->
    <div class="container-fluid">
        <!-- ============================================================== -->
        <!-- Bread crumb and right sidebar toggle -->
        <!-- ============================================================== -->
        <div class="row page-titles">
            <div class="col-md-6 col-8 align-self-center">
                {{--<h3 class="text-themecolor mb-0 mt-0">Recursos</h3>--}}
                <ol class="breadcrumb">
                    <li class="breadcrumb-item"><a href="javascript:void(0)">Encuestas</a></li>
                    <li class="breadcrumb-item active">Crear</li>
                </ol>
            </div>
        </div>
        <div class="row">
            <div class="col">
                <div class="card">
                    <div class="card-body">
                        @include('dashboard.partials.flash-message')
                        <h4 class="card-title">Editar encuesta</h4>
                        {{--<h6 class="card-subtitle"> All with bootstrap element classies </h6>--}}
                        <form id="form-create-poll"  action="{{route('encuestas.update', $poll->id)}}" enctype="multipart/form-data" method="POST">
                            {{csrf_field()}}
                            {{method_field('PUT')}}
                            <input type="hidden" name="poll" value="{{json_encode($poll)}}">
                            <div class="form-group">
                                <label>Pregunta</label>
                                <input type="text" class="form-control" name="question" value="{{$poll->question}}" aria-describedby="emailHelp"
                                       v-model="poll.question"/>
                            </div>
                            <div class="row form-group">
                                <div class="form-group col-6">
                                    <label>Fecha de inicio:</label>
                                    <input type="hidden">
                                    <input type="date" name="date_from" class="form-control" value="{{$poll->date_from}}" v-model="poll.date_from">
                                </div>
                                <div class="form-group col-6">
                                    <label>Fecha de fin:</label>
                                    <input type="date" name="date_to" class="form-control" value="{{$poll->date_to}}" v-model="poll.date_to">
                                </div>
                            </div>
                            <div class="form-group">
                                <label>Respuestas</label>
                                
                                @foreach ($poll->options as $option)
                                    <div  class="d-flex">
                                    <input type="text" class="form-control my-1 mr-1" value="{{$option['option']}}"  name="option" style="display: inline-block"
                                           v-model="poll.options[key]['option']" :disabled="poll.options[key]['disabled']"/>
                                    <button class="btn btn-danger btn-sm my-1 ml-1"
                                            @click.prevent="deleteResponse(key)">Eliminar
                                    </button>
                                </div>
                                @endforeach
                                
                                
                                <button class="btn btn-success btn-sm my-3 d-block" @click.prevent="addResponse">Agregar
                                    respuesta
                                </button>
                            </div>
                            <button type="submit" class="btn btn-primary" @click.prevent="updatePoll">Actualizar
                                encuesta
                            </button>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
    @include('dashboard.partials.footer')
@endsection

@section('script')
       <script>
 $("#exampleModal").modal("show"); $("#exampleModal").css("z-index", "1042");
</script>

<link rel="stylesheet" type="text/css" href="https://cdn.datatables.net/1.10.21/css/dataTables.bootstrap4.min.css" defer/>
<script src="https://cdn.datatables.net/1.10.21/js/jquery.dataTables.min.js" defer ></script>
<script src="https://cdn.datatables.net/1.10.21/js/dataTables.bootstrap4.min.js" defer></script>
<script type="text/javascript">
  $(document).ready( function () {
    $('#example').DataTable();
} );
</script>
@endsection

resources/views/dashboard/polls/index.blade.php
@extends('layouts.dashboard')

@section('content')
    <div id="polls-list" class="container-fluid">
        <div class="row page-titles">
            <div class="col-md-6 col-8 align-self-center">
                {{--<h3 class="text-themecolor mb-0 mt-0">Recursos</h3>--}}
                <ol class="breadcrumb">
                    <li class="breadcrumb-item"><a href="javascript:void(0)">Encuestas</a></li>
                    <li class="breadcrumb-item active">Listado</li>
                </ol>
            </div>
        </div>

        <div class="row">
            <div class="col">
                <div class="card">
                    <div class="card-body">
                        @include('dashboard.partials.flash-message')
                        <h4 class="card-title">Listado de encuestas</h4>
                       <table id="example" class="table table-striped table-bordered" style="width: 100%;">
                            <thead>
                            <tr>
                                <th>Pregunta</th>
                                <th>Fecha de Inicio</th>
                                <th>Fecha de Termino</th>
                                <th>Status</th>
                                <th>Acciones</th>
                            </tr>
                            </thead>
                            <tbody>
                                @foreach ($encuesta as $encuesta)
                                <tr>
                                               <td>{{$encuesta->question}}</td>
                                   <td>{{$encuesta->date_from}}</td>
                                   <td>{{$encuesta->date_to}}</td>
                                  <td>
                                      @if ($encuesta->active != '1')
                                            Inactivo


                                       @else
                                        Activo
                                      @endif
                                  </td>

                               <td>
                                        <a class="btn btn-primary btn-sm" href="{{route('encuestas.edit', $encuesta->id)}}">
                                            <i class="mdi mdi-table-edit"></i>
                                        </a>
                                        <form action="{{route('encuestas.destroy', $encuesta->id)}}" method="POST"
                                              style="display: inline-block">
                                            {{csrf_field()}}
                                            {{method_field('delete')}}
                                            <button class="btn btn-danger btn-sm"><i class="mdi mdi-delete"></i>
                                            </button>
                                        </form>
                                    </td>
                                    </tr>



                                @endforeach
                            </tbody>
                        </table>
                        <div class="clearfix"></div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    @include('dashboard.partials.footer')
@endsection
@section('script')
    <script>
 $("#exampleModal").modal("show"); $("#exampleModal").css("z-index", "1042");
</script>

<link rel="stylesheet" type="text/css" href="https://cdn.datatables.net/1.10.21/css/dataTables.bootstrap4.min.css" defer/>
<script src="https://cdn.datatables.net/1.10.21/js/jquery.dataTables.min.js" defer ></script>
<script src="https://cdn.datatables.net/1.10.21/js/dataTables.bootstrap4.min.js" defer></script>
<script type="text/javascript">
  $(document).ready( function () {
    $('#example').DataTable();
} );
</script>
@endsection